package distraction;

import java.util.*;
import processing.core.*;
import rita.*;

import java.awt.event.*;
import java.net.HttpURLConnection;

// primitive "Processing" style text entry
// the one with web scraping

// Better way:
// Split it up every time (or at good intervals...whenever you do `? Or backspace?)
// Then, the number of `s you do indicate number of words.


public class Distraction3 extends PApplet {

	private static final long serialVersionUID = -3822618250671142677L;

	RiText entry;
	String entryContent, word;
	int lineCount, charCount;
	ArrayList<String> searchTerms;
	// String[] wordArray;

	/**
	 * Setup
	 */
	public void setup() {
		size(800,600);
		RiText.createDefaultFont("courier", 16);

		entry = new RiText(this, 25, 25);
		entryContent = "";
		String word = "";
		searchTerms = new ArrayList<String>();
		
	}

	/**
	 * Text entry
	 */
	// Non-ideal text area. This is a primitive mockup; don't worry about word wrapping yet. I'd like to actually get a text area, get Swing working or something. 
	public void keyPressed() {

		if (key == 'A' || key == 'B' || key == 'C' || key == 'D' || key == 'E' || key == 'F' || key == 'G' || 
				key == 'H' || key == 'I' || key == 'J' || key == 'K' || key == 'L' || key == 'M' || key == 'N' || 
				key == 'O' || key == 'P' || key == 'Q' || key == 'R' || key == 'S' || key == 'T' || key == 'U' || 
				key == 'V' || key == 'W' || key == 'X' || key == 'Y' || key == 'Z' || 
				key == 'a' || key == 'b' || key == 'c' || key == 'd' || key == 'e' || key == 'f' || key == 'g' || 
				key == 'h' || key == 'i' || key == 'j' || key == 'k' || key == 'l' || key == 'm' || key == 'n' || 
				key == 'o' || key == 'p' || key == 'q' || key == 'r' || key == 's' || key == 't' || key == 'u' || 
				key == 'v' || key == 'w' || key == 'x' || key == 'y' || key == 'z' ||
				key == '1' || key == '2' || key == '3' || key == '4' || key == '5' || key == '6' || 
				key == '7' || key == '8' || key == '9' || key == '0' || key == ' ' || key == '-' || key == ';' ||
				key == '=' || key == '[' || key == ']' || key == ',' || key == '.' || key == '/' || key == '\n' || 
				key == '\'') {
			entryContent += key; // add key to content
			entry.setText(entryContent);
			charCount++;
			word += key;
			
		}
		
		// backspacey
		if (key == '\b') {
				
			try {
			if (word != "") 
				word = word.substring(0, word.length() - 1);
			// TODO: split the entry by words and get the last one; not working currently
			else { 
				// wordArray = entryContent.split(" "); // well this isn't working
				// word = wordArray[wordArray.length - 1];
			}	
			} catch (StringIndexOutOfBoundsException e1) {
				return;
			}
			
			entryContent = entryContent.substring(0, entryContent.length() - 1);
			entry.setText(entryContent);
			
			// println("word = '" + word + "'");
			
		}

		if (key == '\n') lineCount++;

		if (charCount == 75) { 
			entryContent += '\n';
			charCount = 0;
			lineCount++;
		}

		// if character is `, add the word to the array. 
		if (key == '`') {
			searchTerms.add(word);
			println(word);
			
			// Now, start querying? Then searchTerms will be not used, but... this makes some sense.
		}

		if (key == ' ') 
			word = "";
	}

	/**
	 * Web scraping. 
	 * Query the words into Google under site:site.com query.
	 * 
	 * Write methods for each site if applicable
	 */
	
	/**
	 * Draw
	 */
	public void draw() {
		background(255);

		// Continually query the words into Twitter.
	}
}
