package distraction;

import processing.core.*;
import javax.swing.*;

import java.awt.*;
import java.util.ArrayList;

import rita.*;

// with AWT, Daniel's suggestions

public class Distraction5 extends PApplet {

	// Interface
	Frame f;
	JTextArea text_area;
	JScrollPane scroll_pane;
	//	RiText searchButton;
	RiText distraction;

	// Web scraping
	ArrayList<String> searchTerms;

	public void setup() {

		// Interface
		size(800, 600);
		background(255);

		text_area = new JTextArea ("",35,65);
		text_area.setWrapStyleWord(true);
		text_area.setLineWrap(true);

		scroll_pane = new JScrollPane(text_area);
		// add(scroll_pane);
		
		f = new JFrame();
		f.setSize(900, 700);

		f.setLayout(null);
		// this.setBounds(new Rectangle(0,0,800,600)); // rectangle
		scroll_pane.setBounds(new Rectangle(0,0,800,600));
		// f.add(this);
		f.add(scroll_pane);
		validate();
		setVisible(true);

		//	searchButton = new RiText(this, "Search", 750, 600);
		//	searchButton.setVisible(true);

		// Web scraping
		searchTerms = new ArrayList<String>();
		
		RiText.createDefaultFont("Helvetica", 36);
		RiText.setDefaultColor(73, 196, 241, 200);
		RiText.setDefaultBBoxFill(73, 196, 241, 200);
		distraction = new RiText(this, "distraction");
		distraction.setVisible(true);

	}

	public void mousePressed() {
		// if (this.mouseX > 725 && this.mouseY > 575 && text_area.getSelectedText() != null) {
		//	if (mouseButton == RIGHT) {
		if (text_area.getSelectedText() != null && mouseButton == RIGHT) {

			searchTerms.add(text_area.getSelectedText());
			println("[SEARCH] " + text_area.getSelectedText());

			// start thread of searching Google/Twitter
			// might not end up needing searchTerms array
			Thread t = new Thread() {
				public void run() {
					search(text_area.getSelectedText());
				}
			};
			t.start();

		}
	}

	public void search(String term) {

		RiHtmlParser fetcher = new RiHtmlParser(this);
		term = term.replace(' ', '+'); 	// convert the term's spaces to pluses

		String url = "http://www.google.com/search?q=\"" + term + "\"";
		// String url = "http://www.google.com/search?q=site:slate.com+\"" + term + "\"";
		// String url = "http://www.google.com/search?q=site:twitter.com%2F*%2Fstatus%2F+\"" + term + "\"";

		// String pageContent = "";

		// pageContent = fetcher.fetch(url, true);
		String[] titles = fetcher.fetchLinkText(url);

		for (int i = 11; i < titles.length - 5; i++) {
			if (!titles[i].contains("Cached") && 
					!titles[i].contains("Similar pages") &&
					(titles[i].length() > 2))
				println(titles[i]);
		}

	}

	public void draw() {
		scroll_pane.repaint();
		text_area.repaint();
		distraction.setVisible(true);
	}
}

/* RiGoogleSearch
 consciously distract self - takes away from the message
 seat in browser experience 
 don't think it's a hard enough task
 tension between setup -> move to referencing environmnet
 don't want to highlight - work out some algorithm - click on a word, etc. - use RiTa to find all words gramatically associated
 Shift and next shift
 
*/
